/**
 * Copyright (c) 2006-2012 ʯſƼ޹˾
 * All rights reserved.
 *
 * @brief 򿪵һӵļ豸ʾζд豸еļ .
 *
 * @version 2.0
 */

#include "stdafx.h"
#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>

#include "common.h"
#include "inc/sample_11.h"

/**< ִļϢ */
#define ET_EXE_FILE_ID		"0001"
#define ET_EXE_FILE_PATH	"hardware\\sample_11_hw.bin"

/**< Ŀ¼Ϣ */
#define ET_SUB_DIRNAME		"0011"
#define SUB_DEV_PIN			"876543218765432187654321"
#define SUB_USR_PIN			"87654321"
#define SUB_SIZE			30000

/**< */
int main(int argc, char* argv[]) {

    ET_CONTEXT pContextList[250] = {0} ;	//豸б
    ET_CONTEXT * pCtx = NULL;   

    DWORD dwDeviceNumber = 0;					//ӵ豸
    DWORD dwResult  = 0;

    unsigned char lpSubName[] = ET_SUB_DIRNAME ;
    DWORD dwSubSize = SUB_SIZE ;
    DWORD dwBytesReturned = 0 ;
   
	BYTE  bUpdateRet = 0 ;
	VM_FILE_CONTEXT fileContext ;
	WORD wTestFileID = 0002 ;

	char szTempBuffer[200] ;
		 

		/**< ʼ豸б */
    dwDeviceNumber = 250 ;
	dwResult = ETEnum( pContextList , &dwDeviceNumber) ;
	if( 0 != dwResult ){
		printf("Enumerate device failed! <error code: 0x%08x>\n", dwResult);
		printf( "\nPress any key to continue...\n"  );
		while ( !kbhit( ) );
		return -1 ;
        
	}
	
    /**<  򿪵һ豸  */
    pCtx = pContextList +0 ;
    dwResult = ETOpen( pCtx );
    if (0 != dwResult) {
 	printf("ETOpen for first device failed with error code:%d\n", dwResult);
      goto FINAL_EXIT ;
    }

     /**< Ŀ¼֤Ŀ¼DEV_PIN */
    printf("Create sub directory [%s] ..... \n" , lpSubName ) ;
    dwResult = createSubdirAtRoot( pCtx , (const char *)lpSubName , dwSubSize , SUB_DEV_PIN , SUB_USR_PIN ,  0xFF , 0xFF ) ;
    if ( dwResult != 0 )  goto FINAL_EXIT ;

    dwResult = ETVerifyPin( pCtx , (unsigned char*)SUB_DEV_PIN , ET_DEV_PIN_LEN, ET_DEV_PIN);
    if ( dwResult != 0 ) {
        printf("Verify the sub directory [%s] DEV_PIN  failed! <error code: 0x%08x>\n", lpSubName , dwResult);
        goto FINAL_EXIT ;
    }
     /**< Ŀ¼´ļ */
    printf("Write hex file to  device....\n");
    dwResult = loadFileIntoDevice( pCtx , ET_EXE_FILE_ID , FILE_TYPE_EXE , ET_EXE_FILE_PATH );
    if (dwResult != 0 ) {
        printf("Write file to device failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
    }

	/**< ļ */
	sprintf(szTempBuffer , "%x", wTestFileID );

	dwResult = ETCreateFile( pCtx , szTempBuffer ,150 , FILE_TYPE_DATA );
    if( dwResult != 0 ){
		printf("Create test file failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
	}

    /**< ûȨ  */
    dwResult = ETVerifyPin( pCtx , (unsigned char *)SUB_USR_PIN , ET_USER_PIN_LEN ,  ET_USER_PIN);
    if (dwResult != 0) {
        printf("Verify USER_PIN failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
    }

	
	/**< ִص豸еļ  */
	printf("Execute program in device...\n");
    /**< ļ */ 
	fileContext.bCommand = CMD_UPDATE_FILE ;
	fileContext.wFileID = wTestFileID;
	fileContext.wOffset = 0 ;
	strcpy ( (char*)fileContext.pbData , "abcdefghijk");
	fileContext.bDataLen = strlen( (const char *)fileContext.pbData ) ;
	
	printf("update file [ id = %x ,  offset = %d , len = %d , data='%s' ]\n" , fileContext.wFileID ,  fileContext.wOffset , fileContext.bDataLen , fileContext.pbData );
    
	dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &fileContext, sizeof(VM_FILE_CONTEXT), &bUpdateRet , 1 , &dwBytesReturned);
   	if (dwResult != 0)
    {
        printf("Execute program in device failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
    }
	
	if(  bUpdateRet != 0 ){
		printf("*internal* update error in device failed! <error code: 0x%08x>\n",bUpdateRet);
         goto FINAL_EXIT ;
	}
	printf("Update the file in device finished ! \n");

	/**< ȡļ */ 
	fileContext.bCommand = CMD_READ_FILE ;
	READ_RESPONSE readData;
	dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &fileContext, sizeof(VM_FILE_CONTEXT), &readData , sizeof(READ_RESPONSE) , &dwBytesReturned);
   	if (dwResult != 0)
    {
        printf("Execute program in device failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
    }
	
	if(  readData.bRetCode != 0 ){
		printf("*internal* read error in device failed! <error code: 0x%08x>\n",bUpdateRet);
        goto FINAL_EXIT ;
	}
	readData.lpBuffer[ fileContext . bDataLen ] = 0 ;
	printf("Read file data '%s'  finished !\n\n\n" , readData.lpBuffer );

FINAL_EXIT:	
    /**< ر豸 */
    dwResult = ETClose( pCtx );

  
	printf( "\nPress any key to continue...\n"  );
    while ( !kbhit( ) );
    return 0 ;

}


