/**
 * Copyright (c) 2006-2012 ʯſƼ޹˾
 * All rights reserved.
 *
 * @brief 򿪵һӵļ豸ʾ豸"device serial""device storage" .
 *
 * @version 2.0
 */

#include "stdafx.h"
#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <conio.h>


#include "ET199_32.h"
/**<  */
int main(int argc, char* argv[]) {

    ET_CONTEXT pContextList[250] = {0} ;	//豸б
    ET_CONTEXT * pCtx = NULL;   

    DWORD dwDeviceNumber = 0;					//ӵ豸
    DWORD dwResult  = 0;

    /**< ʼ豸б */
    dwDeviceNumber = 250 ;
	dwResult = ETEnum( pContextList , &dwDeviceNumber) ;
	if( 0 != dwResult ){
		printf("Enumerate device failed! <error code: 0x%08x>\n", dwResult);
        printf( "\nPress any key to continue...\n"  );
		while ( !kbhit( ) );
		return -1;
	}
	
    /**<  򿪵һ豸  */
    pCtx = pContextList +0 ;
    dwResult = ETOpen( pCtx );
    if (0 != dwResult) {
        printf("ETOpen for first device failed with error code:%d\n", dwResult);
        printf( "\nPress any key to continue...\n"  );
		while ( !kbhit( ) );
		return -1;
    }

    /**<  "device serial"  */
    BYTE lpOutBuf[100] = {0x00,};
    DWORD dwBytesReturned = 0;

    dwResult = ETControl( pCtx , ET_GET_SERIAL_NUMBER , NULL, 0, lpOutBuf, sizeof(lpOutBuf), &dwBytesReturned);
    if ( 0 != dwResult)
        printf("ETControl get  device serial  error :  %d \n", dwResult  );
    else{
        printf("ETControl get  device serial : ") ;
		for( int i = 0 ; i < (int)dwBytesReturned  ; i++ )
			printf("%.2X", lpOutBuf[i] );
		printf("\n");
	}

    /**<  "device storage"   */
    DWORD dwSpaceSize = 0;
    dwResult = ETControl( pCtx , ET_GET_DEVICE_USABLE_SPACE , NULL , 0 , &dwSpaceSize, sizeof(dwSpaceSize), NULL);
    if ( 0 != dwResult)
        printf("ETControl get  device storage error :  %d \n", dwResult  );
    else
        printf("ETControl get  device storage :  %d  BYTE\n", dwSpaceSize  );

    /**< ر豸 */
    dwResult = ETClose( pCtx );


	printf( "\nPress any key to continue...\n"  );
    while ( !kbhit( ) );
    return 0 ;

}


