#include <stdio.h>
#include <string.h>
#include "../../common/et199.h"
#include "../inc/sample_9.h"

 /**< OUT_PACKAGE*/
typedef struct _OPERATE_RESULT
{	
    BYTE bAddCount;
    BYTE bSubCount;
	WORD  iResult ;
 } OPERATE_RESULT ;

void swap(void* pvData,unsigned char bLen)
{
	char i;
	for(i=(char)(bLen-- / 2 - 1);i>=0;i--)
	{
		((char*)pvData)[i] ^= ((char*)pvData)[bLen-i];
		((char*)pvData)[bLen-i] ^= ((char*)pvData)[i];
		((char*)pvData)[i] ^= ((char*)pvData)[bLen-i];
	}
}


xdata OPERATE_RESULT resultVal _at_ 0x400 ;

main()
{
 IN_PACKAGE * xdata pInPackage = NULL ;
 int xdata iReturn = 0;
 
 /**
  * Get the input data from PC at run start up
  * the "pInPackage" is get the data from PC , you must swap numerical data before using it . that is important! 
  * 
  * @see et199.h  about  "pbInBuff" defined
  */
 pInPackage = ( IN_PACKAGE *  ) pbInBuff ;
 _swap( &(pInPackage ->iVal) , sizeof( int  ) ) ;

 switch( pInPackage -> bCommand ){
 	
	case 0:	/**< init the data */
		memset( &resultVal , 0 , sizeof(OPERATE_RESULT) ) ;
		resultVal.iResult = pInPackage ->iVal ; 	
	 	break;
	case 1:	/**< add the data */
	  	resultVal.iResult +=  pInPackage ->iVal ;
	   	resultVal.bAddCount	++ ;
	 	break;
	case 2:	/**< sub the data */
		resultVal.iResult -=  pInPackage ->iVal ;
		resultVal.bSubCount ++ ;
	 	break;
	case 3:	/**< get the result  */
	  	iReturn = resultVal.iResult;
	  	_swap( &iReturn, sizeof( int  ) ) ;/**< swap numerical data*/
	  	_set_response( sizeof( int  ) , &iReturn ) ;
	 	break;
	case 4: /**< get add operate count */
	   	_set_response( 1 , &resultVal.bAddCount ) ;
	 	break;
	case 5:	/**< get sub operate count */
	   	_set_response( 1 , &resultVal.bSubCount ) ;
		break;

 }

 /**< exit the program */
 _exit();

}
