/**
 * Copyright (c) 2006-2012 ʯſƼ޹˾
 * All rights reserved.
 *
 * @brief ʾ豸ʹùڴ棬Ϊм洢 .
 *
 * @version 2.0
 */
#include "stdafx.h"
#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>

#include "common.h"
#include "inc/sample_9.h"
/**< exeļϢ */

#define ET_EXE_FILE_ID		"0001"
#define ET_EXE_FILE_PATH	"hardware\\sample_09_hw.bin"

/**< Ŀ¼Ϣ*/
#define ET_SUB_DIRNAME		"0009"
#define SUB_DEV_PIN			"876543218765432187654321"
#define SUB_USR_PIN			"87654321"
#define SUB_SIZE			3000

/**< */
int main(int argc, char* argv[]) {

    ET_CONTEXT pContextList[250] = {0} ;	//豸б
    ET_CONTEXT * pCtx = NULL;   

    DWORD dwDeviceNumber = 0;					//ӵ豸
    DWORD dwResult  = 0;

    unsigned char lpSubName[] = ET_SUB_DIRNAME ;
    DWORD dwSubSize = SUB_SIZE ;

    DWORD dwBytesReturned = 0 ;

	int  iResult	= 0 ;
	BYTE bAddCount	= 0 ;
	BYTE bSubCount	= 0 ;

  	/**< ʼ豸б */
    dwDeviceNumber = 250 ;
	dwResult = ETEnum( pContextList , &dwDeviceNumber) ;
	if( 0 != dwResult ){
		printf("Enumerate device failed! <error code: 0x%08x>\n", dwResult);
        return -1;
	}
	
    /**<  򿪵һ豸  */
    pCtx = pContextList +0 ;
    dwResult = ETOpen( pCtx );
    if (0 != dwResult) {
        printf("ETOpen for first device failed with error code:%d\n", dwResult);
        return -1;
    }

      /**< Ŀ¼֤Ŀ¼DEV_PIN */
    printf("Create sub directory [%s] ..... \n" , lpSubName ) ;
    dwResult = createSubdirAtRoot( pCtx , (const char *)lpSubName , dwSubSize , SUB_DEV_PIN , SUB_USR_PIN ,  0xFF , 0xFF ) ;
    if ( dwResult != 0 )  goto FINAL_EXIT ;

    dwResult = ETVerifyPin( pCtx , (unsigned char*)SUB_DEV_PIN , ET_DEV_PIN_LEN, ET_DEV_PIN);
    
	if ( dwResult != 0 ) {
        printf("Verify the sub directory [%s] DEV_PIN  failed! <error code: 0x%08x>\n", lpSubName , dwResult);
        goto FINAL_EXIT ;
    }
      /**< Ŀ¼´ļ */
    printf("Write hex file to  device....\n");
    dwResult = loadFileIntoDevice( pCtx , ET_EXE_FILE_ID , FILE_TYPE_EXE , ET_EXE_FILE_PATH );
    if (dwResult != 0 ) {
        printf("Write file to device failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
    }

     /**< ûȨ  */
    dwResult = ETVerifyPin( pCtx , (unsigned char *)SUB_USR_PIN , ET_USER_PIN_LEN ,  ET_USER_PIN);
    if (dwResult != 0) {
        printf("Verify USER_PIN failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
    }

    /**< ִص豸еļ  */
	printf("Execute program in device...\n");
    IN_PACKAGE inPackage ;
	
	/**< ʼ */ 
	inPackage.bCommand = 0 ;
	inPackage.iVal = 5 ;
	dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &inPackage, sizeof(IN_PACKAGE), NULL, 0, &dwBytesReturned);
   	if (dwResult != 0)
    {
        printf("Execute program in device failed! <error code: 0x%08x>\n",dwResult);
        goto FINAL_EXIT ;
    }


	/**< Ӳ */
	inPackage.bCommand = 1 ; 
	inPackage.iVal = 8 ;
    dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &inPackage, sizeof(IN_PACKAGE), NULL, 0, &dwBytesReturned);

	inPackage.bCommand = 2 ;
	inPackage.iVal = 4 ;
    dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &inPackage, sizeof(IN_PACKAGE), NULL, 0, &dwBytesReturned);
	
	inPackage.bCommand = 1 ;
	inPackage.iVal = 7 ;
    dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &inPackage, sizeof(IN_PACKAGE), NULL, 0, &dwBytesReturned);

	/**< òͽ */
	inPackage.bCommand = 3 ;
	dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &inPackage, sizeof(int), &iResult, sizeof(int), &dwBytesReturned);
	inPackage.bCommand = 4 ;
	dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &inPackage, sizeof(BYTE), &bAddCount, sizeof(int), &dwBytesReturned);
	inPackage.bCommand = 5 ;
	dwResult =ETExecute( pCtx , ET_EXE_FILE_ID,  &inPackage, sizeof(BYTE), &bSubCount, sizeof(int), &dwBytesReturned);

	printf("The result is %d , addcount %d , subcount %d \n\n\n" , iResult , bAddCount , bSubCount ) ;

FINAL_EXIT:
	/**< ر豸*/
    dwResult = ETClose( pCtx );

    printf( "\nPress any key to continue...\n"  );
    while ( !kbhit( ) );
    return 0 ;

}


