{**************************************************************************************
* Copyright (c)
* All rights reserved.
*
* FileName
*
* History:
*  ------------------------------------------------------------
*  2007/01/30   modified
*
*******************************************************************************************}
unit helpET199;

interface

uses
  SysUtils, Windows ;

 // const definition
const     ET_S_SUCCESS						=$00000000;			// ɹ*/
const     ET_E_KEY_REMOVED					=$F0000001;			// 豸δӣ߱Ƴ*/
const     ET_E_INVALID_PARAMETER				=$F0000002;			// */
const     ET_E_COMM_ERROR					=$F0000003;			// ͨѶݴ䳬ʱ*/
const     ET_E_INSUFFICIENT_BUFFER				=$F0000004;			// ռ䲻*/
const     ET_E_NO_LIST						=$F0000005;						// ûҵ豸б*/
const     ET_E_DEVPIN_NOT_CHECK					=$F0000006;						// ̿û֤*/
const     ET_E_USERPIN_NOT_CHECK				=$F0000007;						// ûû֤*/
const  	  ET_E_RSA_FILE_FORMAT_ERROR			        =$F0000008;						// RSAļʽ*/
const     ET_E_DIR_NOT_FOUND					=$F0000009;						// Ŀ¼ûҵ*/
const     ET_E_ACCESS_DENIED					=$F000000A;						// ʱܾ*/
const     ET_E_ALREADY_INITIALIZED				=$F000000B;						// ƷѾʼ*/
const     ET_E_INCORRECT_PIN					=$F0000C00;						// 벻ȷ*/
const     ET_E_DF_SIZE						=$F000000D;						// ָĿ¼ռС*/
const     ET_E_FILE_EXIST					=$F000000E;						// ļѴ*/
const     ET_E_UNSUPPORTED					=$F000000F;						// ֻ֧ܲδļϵͳ*/
const     ET_E_FILE_NOT_FOUND					=$F0000010;						// δҵָļ*/
const  	  ET_E_ALREADY_OPENED					=$F0000011;						// Ѿ*/
const     ET_E_DIRECTORY_EXIST					=$F0000012;						// Ŀ¼Ѵ*/
const     ET_E_CODE_RANGE					=$F0000013;						// ڴַ*/
const     ET_E_INVALID_POINTER					=$F0000014;						// ָ */
const     ET_E_GENERAL_FILESYSTEM				=$F0000015;						// ļϵͳ */
const     ET_E_OFFSET_BEYOND					=$F0000016;						// ļƫļС*/
const     ET_E_FILE_TYPE_MISMATCH				=$F0000017;						// ļͲƥ*/
const     ET_E_PIN_BLOCKED					=$F0000018;						// PIN*/
const     ET_E_INVALID_CONTEXT					=$F0000019;						// ETContext */
const     ET_E_ERROR_UNKNOWN					=$FFFFFFFF;						// δ֪Ĵ*/

const  	  MAX_ATR_LEN						=16;                              // ATR */
const     MAX_ID_LEN						=8;                               // ӲID*/

const     ET_USER_PIN						=$00000000;                      // ûPIN*/
const     ET_DEV_PIN						=$00000001;                      // PIN*/

const     ET_CREATE_NEW						=$00000000;                      // ļ*/
const     ET_UPDATE_FILE					=$00000001;                      // ļ*/

const     ET_CREATE_ROOT_DIR					=$00000000;                      // Ŀ¼*/
const     ET_CREATE_SUB_DIR					=$00000001;                      // ǰĿ¼Ŀ¼*/


const     ET_LED_UP						=$00000001;						// LED*/
const     ET_LED_DOWN						=$00000002;						// LED*/
const     ET_LED_WINK						=$00000003;						// LED˸*/


const     ET_GET_DEVICE_TYPE					=$00000011;                      // 豸*/
const     ET_GET_SERIAL_NUMBER					=$00000012;                      // ȡӲк*/
const     ET_GET_DEVICE_USABLE_SPACE			        =$00000013;                      // 豸ռС*/
const     ET_GET_DEVICE_ATR					=$00000014;                      // 豸ATR*/
const     ET_GET_CUSTOMER_NAME					=$00000015;                      // ÿͻ*/
const     ET_GET_MANUFACTURE_DATE				=$00000016;                      // */
const     ET_GET_DF_AVAILABLE_SPACE				=$00000017;                      // õǰĿ¼ʣռ*/
const     ET_GET_EF_INFO					=$00000018;                      // ָļϢ*/
const     ET_GET_COS_VERSION					=$00000019;						// COS汾Ϣ*/

const     ET_SET_DEVICE_ATR					=$00000021;                      // 豸ATR*/
const     ET_SET_TOKEN_TYPE					=$00000022;						// ÿ*/
const     ET_SET_SHELL_KEY					=$00000023;						// 8ֽǼ*/

const     ET_RESET_DEVICE					=$00000031;                      // λ豸*/


const     ET_TOKEN_TYPE_PKI					=$01;							// ֤*/
const     ET_TOKEN_TYPE_DONGLE					=$02;							// */
const     ET_TOKEN_TYPE_EMPTY					=$04;							// */


const     ET_DEFAULT_TRY					=$ff;							// ĬԴ޴Σ*/

const  	  ET_DEFAULT_DEV_PIN					='123456781234567812345678';
const     ET_DEFAULT_USER_PIN					='12345678';
const     ET_DEV_PIN_LEN					=24;
const     ET_USER_PIN_LEN					=8;


const  	 ET_EXCLUSIZE_MODE					=0;                               // ռģʽ*/
const    ET_SHARE_MODE						=1;                               // ģʽ*/

const    FILE_TYPE_EXE						=0;								// ִļ*/
const    FILE_TYPE_DATA						=1;								// ļ*/
const    FILE_TYPE_RSA_PUBLIC					=2;								// RSA Կļ*/
const    FILE_TYPE_RSA_PRIVATE					=3;								// RSA ˽Կļ*/
const    FILE_TYPE_INTERNAL_EXE					=4;								//  ִļɶд*/

 

 type

  PWord = ^Word;
  PLongword = ^Longword;
  PHIDP_PREPARSED_DATA = ^Byte;
  PPHIDP_PREPARSED_DATA = ^PHIDP_PREPARSED_DATA;
  PCSTR = ^Char;
  PByte = ^Byte;
  psize_t = ^size_t;
  size_t = Cardinal;

  PET_CONTEXT = ^ET_CONTEXT;
  ET_CONTEXT = record
        dwIndex:Longword;
        dwVersion:Longword;
        hLock:THANDLE;
        reserve: array [0..11] of Byte;
        dwCustomer: Longword;
        bAtr: array [0..MAX_ATR_LEN-1] of Byte;
        bID: array [0..MAX_ID_LEN-1] of Byte;
        dwAtrLen: Longword;
  end;

  CREATEDIRINFO = record
        dwCreateDirInfoSize:Longword;
        szAtr:array [0..7] of Byte;
  end;
  PCREATEDIRINFO = ^CREATEDIRINFO;

  //{$EXTERNALSYM _CheckDeviceCapabilities}
  //function _CheckDeviceCapabilities(DeviceHandle : PChar ):DWORD;stdcall;
  //{$EXTERNALSYM TransmitAPDU}
  //function TransmitAPDU(hic:integer ; apdu :PChar ):integer;stdcall;
  {$EXTERNALSYM ETEnum}
  function ETEnum( pETContextList : PET_CONTEXT ; pdwContextListSize :PLongword):integer;stdcall;
  {$EXTERNALSYM ETOpen}
  function ETOpen( pCtx : PET_CONTEXT ):integer;stdcall;
  {$EXTERNALSYM ETClose}
  function ETClose( pCtx : PET_CONTEXT ):integer;stdcall;
  {$EXTERNALSYM ETControl}
  function ETControl( pCtx : PET_CONTEXT ; dwCtlCode:Longword ; pInBuffer :PChar ; dwInBufferLen:Longword; pOutBuffer:PChar;dwOutBufferLen:Longword; pdwBytesReturned:PLongword) :integer;stdcall;
  {$EXTERNALSYM ETCreateDir}
  function ETCreateDir( pCtx :PET_CONTEXT; lpszDirID:PChar; dwDirSize:Longword; dwFlags:Longword ):integer;stdcall;
  {$EXTERNALSYM ETChangeDir}
  function ETChangeDir(pCtx :PET_CONTEXT; lpszPath:PChar):integer;stdcall;
  {$EXTERNALSYM ETEraseDir}
  function ETEraseDir( pCtx :PET_CONTEXT; lpszDirID:PChar):integer;stdcall;
  {$EXTERNALSYM ETVerifyPin}
  function ETVerifyPin(pCtx :PET_CONTEXT; pbPin:PChar; dwPinLen:Longword; dwPinType:Longword):integer;stdcall;
  {$EXTERNALSYM ETChangePin}
  function ETChangePin(pCtx :PET_CONTEXT; pbOldPin:PChar; dwOldPinLen:Longword; pbNewPin:PChar; dwNewPinLen:Longword; dwPinType:Longword; byPinTryCount:Byte ):integer;stdcall;
  {$EXTERNALSYM ETWriteFile}
  function ETWriteFile(pCtx :PET_CONTEXT; lpszFileID:PChar; dwOffset:LongWord; pBuffer:PByte; dwBufferSize:Longword ):integer;stdcall;
  {$EXTERNALSYM ETWriteFileEx}
  function ETWriteFileEx(pCtx :PET_CONTEXT; lpszFileID:PChar; dwOffset:Longword; pBuffer:PByte; dwBufferSize:Longword; dwFileSize:Longword; pdwBytesWritten:PLongword; dwFlags:Longword; bFileType:Byte ):integer;stdcall;
  {$EXTERNALSYM ETExecute}
  function ETExecute(pCtx :PET_CONTEXT;	lpszFileID:PChar; pInBuffer:PByte; dwInbufferSize:Longword; pOutBuffer:PByte;  dwOutBufferSize:Longword; pdwBytesReturned:PLongword ):integer;stdcall;
  //{$EXTERNALSYM ETCreateDirEx}
  //function ETCreateDirEx( pCtx :PET_CONTEXT; lpszDirID:PChar; dwDirSize:Longword; dwFlags:Longword; pCreateDirInfo:PCREATEDIRINFO ):integer;stdcall;
  {$EXTERNALSYM ETCreateFile}
  function ETCreateFile( pCtx :PET_CONTEXT; lpszFileID:PChar; dwFileSize:Longword; bFileType:Byte ):integer;stdcall;
  //{$EXTERNALSYM PETWriteFile}
  //function PETWriteFile ( pCtx :PET_CONTEXT; lpszFileID:PChar; lpszPCFilePath:PChar; pdwFileSize:PLongword; dwFlags:Longword; dwFileType:Longword; pdwBytesWritten:PLongword ):integer;stdcall;
  {$EXTERNALSYM ETGenRsaKey}
  function ETGenRsaKey( pCtx :PET_CONTEXT; wKeySize:Word; dwE:Longword; lpszPubFileID:PChar; lpszPriFileID:PChar; pbPubKeyData:PByte; dwPubKeyDataSize:PLongword; pbPriKeyData:PByte; dwPriKeyDataSize:PLongword):integer;stdcall;
  {$EXTERNALSYM ETFormatErrorMessage}
  function ETFormatErrorMessage( dwRet:Longword; lpszMessage:PChar; dwMsgBufLen:Longword):integer;stdcall;


  type
    GUID = record
        Data1:Longword;
        Data2:Word;
        Data3:Word;
        Data4: array [0..7] of Byte;
  end;

  Array128 =  array[0..127]of WORD;
  pArray128 = ^Array128;

  LPGUID = ^GUID;

  HIDP_CAPS = record
        Usage:Word;
        UsagePage:Word;
        InputReportByteLength:Word;
        OutputReportByteLength:Word;
        FeatureReportByteLength:Word;
        Reserved: array [0..16] of Word;
        NumberLinkCollectionNodes:Word;
        NumberInputButtonCaps:Word;
        NumberInputValueCaps:Word;
        NumberInputDataIndices:Word;
        NumberOutputButtonCaps:Word;
        NumberOutputValueCaps:Word;
        NumberOutputDataIndices:Word;
        NumberFeatureButtonCaps:Word;
        NumberFeatureValueCaps:Word;
        NumberFeatureDataIndices:Word;
  end;

  PHIDP_CAPS = ^HIDP_CAPS;

  HIDD_ATTRIBUTES = record
        Size:Longword;
        VendorID:Word;
        ProductID:Word;
        VersionNumber:Word;
  end;

  PHIDD_ATTRIBUTES = ^HIDD_ATTRIBUTES;

  SP_DEVICE_INTERFACE_DATA = record
        cbSize:Longword;
        InterfaceClassGuid:GUID;
        Flags:Longword;
        Reserved:Longword;
  end;

  PSP_DEVICE_INTERFACE_DATA = ^SP_DEVICE_INTERFACE_DATA;

  SP_DEVICE_INTERFACE_DETAIL_DATA_A = record
        cbSize:Longword;
        DevicePath: array [0..4096] of Char;
  end;

  PSP_DEVICE_INTERFACE_DETAIL_DATA_A = ^SP_DEVICE_INTERFACE_DETAIL_DATA_A;
  PSP_DEVICE_INTERFACE_DETAIL_DATA = ^SP_DEVICE_INTERFACE_DETAIL_DATA_A;

  SP_DEVINFO_DATA = record
        cbSize:Longword;
        ClassGuid:GUID;
        DevInst:Longword;
        Reserved:Longword;
  end;

  PSP_DEVINFO_DATA = ^SP_DEVINFO_DATA;
  Feature_Report = packed record
        id: Byte;
        command: array[0..4] of Byte;
        data: array[0..17] of Byte;
        CrcData: Byte;
  end;

  PFeature_Report = ^Feature_Report;

  Device_Descript = record
        device_path: array[0..255] of Char;
        device_handle: THandle;
        uid: Longword;
        hid: Longword;
        hver: Word;
        mutex: THandle;
        KeyPass:array[0..8] of char;
        Encrypt:integer;
  end;
  {$EXTERNALSYM HidD_FreePreparsedData}
  function HidD_FreePreparsedData (PreparsedData:PHIDP_PREPARSED_DATA):Boolean;cdecl;
  {$EXTERNALSYM HidP_GetCaps}
  function HidP_GetCaps (PreparsedData:PHIDP_PREPARSED_DATA; Capabilities:PHIDP_CAPS):Longint;cdecl;
  {$EXTERNALSYM HidD_GetPreparsedData}
  function HidD_GetPreparsedData (HidDeviceObject:THandle; PreparsedData:PPHIDP_PREPARSED_DATA):Boolean;cdecl;
  {$EXTERNALSYM HidD_SetFeature}
  function HidD_SetFeature (HidDeviceObject:THandle; ReportBuffer:pointer; ReportBufferLength:Longword):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetFeature}
  function HidD_GetFeature (HidDeviceObject:THandle; ReportBuffer:pointer; ReportBufferLength:Longword):Boolean;cdecl;
  {$EXTERNALSYM HidD_FlushQueue}
  function HidD_FlushQueue (HidDeviceObject:THandle):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetSerialNumberString}
  function HidD_GetSerialNumberString(HidDeviceObject:THandle; Buffer:PChar; BufferLength:Longword):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetProductString}
  function HidD_GetProductString(HidDeviceObject:THandle; Buffer:PChar; BufferLength:Longword):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetAttributes}
  function HidD_GetAttributes (HidDeviceObject:THandle; Attributes:PHIDD_ATTRIBUTES):Boolean;cdecl;
  {$EXTERNALSYM HidD_GetHidGuid}
  function HidD_GetHidGuid ( HidGuid:LPGUID ):integer;cdecl;
  {$EXTERNALSYM HidD_GetManufacturerString}
  function HidD_GetManufacturerString(HidDeviceObject:THANDLE;Buffer:PCHAR; BufferLength:ULONG):Boolean;cdecl;

  {$EXTERNALSYM SetupDiDestroyDeviceInfoList}
  function SetupDiDestroyDeviceInfoList (DeviceInfoSet:THandle):Boolean;cdecl;
  {$EXTERNALSYM SetupDiGetDeviceInterfaceDetailA}
  function SetupDiGetDeviceInterfaceDetailA (DeviceInfoSet:THandle; DeviceInterfaceData:PSP_DEVICE_INTERFACE_DATA; DeviceInterfaceDetailData:PSP_DEVICE_INTERFACE_DETAIL_DATA_A; DeviceInterfaceDetailDataSize:Longword; RequiredSize:PLongword; DeviceInfoData:PSP_DEVINFO_DATA):Boolean;cdecl;
  {$EXTERNALSYM SetupDiEnumDeviceInterfaces}
  function SetupDiEnumDeviceInterfaces (DeviceInfoSet:THandle; DeviceInfoData:PSP_DEVINFO_DATA; InterfaceClassGuid:LPGUID; MemberIndex:Longword; DeviceInterfaceData:PSP_DEVICE_INTERFACE_DATA):Boolean;cdecl;
  {$EXTERNALSYM SetupDiGetClassDevsA}
  function SetupDiGetClassDevsA (ClassGuid:LPGUID; Enumerator:PCSTR; hwndParent:HWND; Flags:Longword):THandle;cdecl;

  {$EXTERNALSYM _memset}
  function _memset(s: Pointer; c: Integer; n: size_t): Pointer; cdecl;
  {$EXTERNALSYM _memcpy}
  function _memcpy(s1: Pointer; const s2: Pointer; n: size_t): Pointer; cdecl;
  {$EXTERNALSYM _memcmp}
  function _memcmp(s1: Pointer; const s2: Pointer; n: size_t): Integer; cdecl;
  {$EXTERNALSYM _strcpy}
  function _strcpy(s1: PChar; const s2: PChar): PChar; cdecl;
  {$EXTERNALSYM _strlen}
  function _strlen(const s: PChar): size_t; cdecl;
  {$EXTERNALSYM _strcmp}
  function _strcmp(const s1, s2: PChar): Integer; cdecl;
  {$EXTERNALSYM _strncmp}
  function _strncmp(const s1, s2: PChar; n: size_t): Integer; cdecl;
  {$EXTERNALSYM _strncpy}
  function _strncpy(s1: PChar; const s2: PChar; n: size_t): PChar; cdecl;
  {$EXTERNALSYM _sscanf}
  function _sscanf(const s, format: PChar): Integer; cdecl; varargs;
  {$EXTERNALSYM _sprintf}
  function _sprintf(s: PChar; const format: PChar): Integer; cdecl; varargs;

implementation

const
msvcrtdll       = 'msvcrt.dll';
hiddll          = 'HID.DLL';
setupapidll     = 'SETUPAPI.DLL';

//et199 functions
//{$LINK 'ETCore.obj'} //ⲿOBJļ
//{$LINK 'ET199.obj'} //ⲿOBJļ
  {$LINK 'et199_delphi.obj'} //ⲿOBJļ
  //function _CheckDeviceCapabilities;external ;
  //function TransmitAPDU;external ;
  function ETEnum;external ;
  function ETOpen;external ;
  function ETClose;external  ;
  function ETControl;external ;
  function ETCreateDir;external ;
  function ETChangeDir;external ;
  function ETEraseDir;external ;
  function ETVerifyPin;external;
  function ETChangePin;external;
  function ETWriteFile;external;
  function ETWriteFileEx;external;
  function ETExecute;external;
  //function ETCreateDirEx;external;
  function ETCreateFile;external;
  //function PETWriteFile ;external;
  function ETGenRsaKey;external;
  function ETFormatErrorMessage;external;


//hid function
function HidD_FreePreparsedData ; external hiddll name 'HidD_FreePreparsedData' ;
function HidP_GetCaps; external hiddll name 'HidP_GetCaps' ;
function HidD_GetPreparsedData ; external hiddll name 'HidD_GetPreparsedData' ;
function HidD_SetFeature ; external hiddll name 'HidD_SetFeature' ;
function HidD_GetFeature ; external hiddll name 'HidD_GetFeature' ;
function HidD_FlushQueue ; external hiddll name 'HidD_FlushQueue';
function HidD_GetSerialNumberString; external hiddll name 'HidD_GetSerialNumberString';
function HidD_GetProductString; external hiddll name 'HidD_GetProductString';
function HidD_GetAttributes ; external hiddll name 'HidD_GetAttributes';
function HidD_GetHidGuid ; external hiddll name 'HidD_GetHidGuid';
function HidD_GetManufacturerString; external hiddll name 'HidD_GetManufacturerString';

//setupapi function
function SetupDiDestroyDeviceInfoList ; external setupapidll name 'SetupDiDestroyDeviceInfoList';
function SetupDiGetDeviceInterfaceDetailA ; external setupapidll name 'SetupDiGetDeviceInterfaceDetailA';
function SetupDiEnumDeviceInterfaces ;external setupapidll name 'SetupDiEnumDeviceInterfaces' ;
function SetupDiGetClassDevsA ; external setupapidll name 'SetupDiGetClassDevsA';

//msvcrt function
function _memset; external msvcrtdll name 'memset';
function _memcpy; external msvcrtdll name 'memcpy';
function _memcmp; external msvcrtdll name 'memcmp';
function _strcpy; external msvcrtdll name 'strcpy';
function _strlen; external msvcrtdll name 'strlen';
function _strcmp; external msvcrtdll name 'strcmp';
function _strncmp; external msvcrtdll name 'strncmp';
function _strncpy; external msvcrtdll name 'strncpy';
function _sscanf; external msvcrtdll name 'sscanf';
function _sprintf; external msvcrtdll name 'sprintf';

end.















































































































































