import com.ET199.*;
import java.io.*;

public class ET199test
{
	public static void main(String args[])
	{
		try
		{
			System.out.println("et199 test begin...");
			//(1)öټ
			System.out.println("\nöټ...");
			int nDevCount = ET199.Enum();
			System.out.println(nDevCount);
			
			//(2)Ϊ0ļ
			System.out.println("\n򿪼0...");
			ET199 et = new ET199(0);
			displayDeviceInfo(et);
				                
			byte[] byDevPinDefault = 
			{
	                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38,
	                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38,
	                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
               		 };
			try
			{
				//(3)лĿ¼
				System.out.println("\nлĿ¼...");
				et.ChangeDir("\\");
				//(4)֤pin
				System.out.println("\n֤pin...");
				et.VerifyPin(byDevPinDefault,ET199.ET_DEV_PIN);
				//(5)ɾĿ¼
				System.out.println("\nɾĿ¼...");
				et.EraseDir(null);
			}
			catch(ET_EXCEPTION e)
			{
				if(e.getExceptionCode() == et.ET_E_DIR_NOT_FOUND)
				{
					System.out.println("ET199 exception:"+e.getReason());
				}
				else
				{
					throw e;
				}
			}
			//(6)Ŀ¼
			System.out.println("\nĿ¼...");
			et.CreateDir(null,0,ET199.ET_ROOT_DIR);
			
			//(7)֤pin
			System.out.println("\n֤pin...");
			et.VerifyPin(byDevPinDefault,ET199.ET_DEV_PIN);
			
			//(8)LED˸
	                final int nLedFreq = 5;
	                byte[] byLedFreq = {(byte)nLedFreq, 0, 0, 0};
	                System.out.println("\nLED˸ƵΪ" + nLedFreq + "...");
	                et.Control(ET199.ET_LED_WINK, byLedFreq, 4, null, null);  
	                
			//(9)Ŀ¼
	                String strSubDirID = "5678";
	                System.out.println("\nĿ¼,IDΪ"+strSubDirID+"...");
	                et.CreateDir(strSubDirID, 0x2000, ET199.ET_SUB_DIR);
	                
	                //(10)Ŀpin
	                System.out.println("\nĿpin...");
	                byte[] byDevPinNew = 	                
	                {
	                    0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31,
	                    0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31,
	                    0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31
	                };
                	et.ChangePin(byDevPinDefault, byDevPinNew, ET199.ET_DEV_PIN, (byte)0xff);
                	
			//(11)һִļ
			String strExeFileID = "1234";
			System.out.println("\nһִļ,IDΪ"+strExeFileID+"...");
			et.CreateFile(strExeFileID,0x1000,(byte)0);
			
			//(12)дݵִļ
			System.out.println("\nдݵִļ"+strExeFileID + "...");
			writeExeFileData(et,strExeFileID,"hardware\\hardware.bin");
			
			//(13)֤ûpin
			System.out.println("\n֤ûpin...");
			byte[] byUserPin = 	                
	                {
	                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
	                };
			et.VerifyPin(byUserPin,ET199.ET_USER_PIN);
			
			//(14)пִг
			System.out.println("\nпִг"+strExeFileID+"...");
			byte[] byOutBuffer = new byte[32];
			int[] nOutLen = new int[1];
			et.Execute(strExeFileID,null,0,byOutBuffer,nOutLen);
						
			//(15)ȡļϢ
			System.out.println("\nȡļϢ...");			
			byte[] fi = new byte[5];
			fi[0] = 0x31;
			fi[1] = 0x32;
			fi[2] = 0x33;
			fi[3] = 0x34;
			int[] retlen = new int[1];
			et.Control(ET199.ET_GET_EF_INFO,fi,4,fi,retlen);
			
			//(16)֤pin
	                System.out.println("\n֤pin...");
	                et.VerifyPin(byDevPinNew, ET199.ET_DEV_PIN);
	                
			//(17)Կ
			byte[] byPubKeyData = new byte[1024];
			byte[] byPriKeyData = new byte[1024];
			int[] nPubKeyLen = new int[1];
			int[] nPriKeyLen = new int[1];
			System.out.println("\nԿ...");
			et.GenRsaKey((short)1024,0x10001,"1111","2222",byPubKeyData,nPubKeyLen,byPriKeyData,nPriKeyLen);
			
			//(18)лһĿ¼(Ŀ¼)
			System.out.println("\nлһĿ¼...");
			et.ChangeDir("..");
			
			//(19)豸
	                System.out.println("\n豸...");
	                int[] nBytesReturn = new int[1];
	                et.Control(ET199.ET_RESET_DEVICE, null, 0, null, nBytesReturn);
	
	                //(20)֤pin
	                System.out.println("\n֤pin...");
	                et.VerifyPin(byDevPinDefault, ET199.ET_DEV_PIN);
	
	                //(21)ɾĿ¼
	                System.out.println("\nɾĿ¼...");
		            et.EraseDir(null);
	
	                //(22)Ŀ¼
	                System.out.println("\nĿ¼...");
	                et.CreateDir("\\", 0, ET199.ET_ROOT_DIR);
	
	                //(23)ر豸
	                System.out.println("\nر豸...");
		        et.Close();
	
	                System.out.println("\nET199 test end");
		}
		catch(ET_EXCEPTION e)
		{
			System.out.println("ET199 exception:" + e.getReason());
		}
		catch(Exception e)
		{
			System.out.println(e.getCause());
		}
	}
	private static void displayDeviceInfo(ET199 et)
	{
		int nVersion = et.GetVersion();
		System.out.print("Version:\t" + nVersion/256 + '.' );
		String strtemp = "00"+ String.valueOf((byte)nVersion);
		strtemp = strtemp.substring(strtemp.length()-2,strtemp.length());
		System.out.println( strtemp );
	
		System.out.println("Customer:\t" + Integer.toHexString(et.GetCustomer()));
		String str = new String(et.GetAtr());
		System.out.println("Atr:\t\t" + str);
		byte[] byID = et.GetID();
		System.out.print("ID:\t\t");
		for (int i = 0; i <= (byID.length - 1); i++)
		{
			if (0 == byID[i] / 0x0f)
				System.out.print("0");
			System.out.print(Integer.toHexString(byID[i] & 0xff));
		}
		System.out.println();		
	}
	private static void writeExeFileData(ET199 et,String strFileID,String strFilePath)throws FileNotFoundException,Exception
	{
		File f = new File(strFilePath);
		FileInputStream fs = new FileInputStream(f);
		if(f.length() > 10240)
		{
			throw new Exception("ļ̫");
		}
		byte[] data = new byte[(int)f.length()];
		fs.read(data);
		et.WriteFile(strFileID,0,data,(int)f.length());
	}	
}
