// Test.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"
#include <windows.h>
#include "et199_32.h"
#include "time.h"

VOID PostError(char * Perfix,DWORD dwErr)
{
	char sErr[128];
	ETFormatErrorMessage(dwErr,sErr,sizeof(sErr));
	printf("%s Error:%s",Perfix,sErr);
}

int _tmain(int argc, _TCHAR* argv[])
{
	DWORD dwRet;
	DWORD Frq = 5;//0.5˸һ
	DWORD dwCount=0;
	ET_CONTEXT *pContext;
	DWORD TokenSize,DFSize;
	WORD id=0x1001;
	COS_RSA_PUBLIC_KEY_1024 pubKeyData;
	COS_RSA_CRT_PRIVATE_KEY_1024 priKeyData;
	DWORD pubSize = sizeof(COS_RSA_PUBLIC_KEY_1024),priSize = sizeof(COS_RSA_CRT_PRIVATE_KEY_1024);
	HANDLE hFile;
	DWORD FileSize;
	struct tm time;
	unsigned char product_nameid;
	unsigned char FileBuff[10240];
	unsigned char InBuf[256],OutBuf[256];
	char szAtr[MAX_ATR_LEN+1];//0

	//öET199
	dwRet=ETEnum(NULL,&dwCount);

	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
		return dwRet;

	//ڴڴ洢CONTEXTṹ
	pContext = new ET_CONTEXT[dwCount];

	//0
	memset(pContext,0,sizeof(ET_CONTEXT)*dwCount);

	//ʹ÷Ļ½ö
	dwRet=ETEnum(pContext,&dwCount);
	if(dwRet)
		return dwRet;

	printf("Find ET199 %d\n",dwCount);

	//ET199
	dwRet = ETOpen(&pContext[0]);
	if(dwRet)
		return dwRet;
	
	printf("Open ET199: \n");
	printf("COS Version: %d.%02d\n",pContext[0].dwVersion>>8 & 0xff,pContext[0].dwVersion & 0xff);
	printf("HardSerial: ");
	for(int i=0;i<8;i++) printf("%02X",pContext[0].bID[i]);
	printf("\n");
	printf("ATR:%s\n",pContext[0].bAtr);
	printf("Customer:%X\n",pContext[0].dwCustomer);

	if(pContext[0].dwCustomer != 0x1234) //滻ԼĿͻ
	{
		//ԼļӦرȣ
	}	
	
	//LED˸ ƵΪFrq
	dwRet = ETControl(&pContext[0],ET_LED_WINK,&Frq,sizeof(Frq),NULL,0,NULL);
	if(dwRet)
	{
		PostError("ETControl ET_LED_WINK",dwRet);
		goto END;
	}

	dwRet = ETControl(&pContext[0],ET_GET_DEVICE_USABLE_SPACE,NULL,0,&TokenSize,4,NULL);
	if(dwRet)
	{
		PostError("ETControl",dwRet);
		goto END;
	}
	printf("TokenSize:%dK\n",TokenSize/1024);

	dwRet = ETControl(&pContext[0],ET_GET_PRODUCT_NAMEID,NULL,0,&product_nameid,4,NULL);
	if(dwRet)
	{
		PostError("ETControl",dwRet);
		goto END;
	}

	switch(product_nameid)
	{
	case 0:
		printf("Found et199\n");
		break;

	case 1:
		printf("Found et199\n");
		break;

	default:
		printf("Unknown error!\n");
		goto END;
	}

	if(product_nameid == 1)
	{
		dwRet = ETControl(&pContext[0],ET_GET_CURRENT_TIME,NULL,0,&time,sizeof(struct tm),NULL);
		if(dwRet)
		{
			PostError("ETControl",dwRet);
			goto END;
		}
		printf("ʱ: %0.2d%0.2d%0.2d %0.2d:%0.2d:%0.2d\n", time.tm_year+1900, time.tm_mon + 1
			, time.tm_mday, time.tm_hour, time.tm_min, time.tm_sec);
	}

	//лĿ¼,Ŀ¼Ƿ	
	dwRet = ETChangeDir(&pContext[0],"\\");
	if(!dwRet)
	{
		//ʹĬϿ֤̿ĬϿҪ滻ԼĿ
		dwRet = ETVerifyPin(&pContext[0],ET_DEFAULT_DEV_PIN,ET_DEV_PIN_LEN,ET_DEV_PIN);
		if(dwRet)
		{
			PostError("ETVerifyPin",dwRet);
			goto END;
		}
		//ɾĿ¼
		dwRet = ETEraseDir(&pContext[0],NULL);
		if(dwRet)
		{
			PostError("ETEraseDir",dwRet);
			goto END;
		}
	}
	
	//Ŀ¼
	dwRet = ETCreateDir(&pContext[0],NULL,0,ET_CREATE_ROOT_DIR);
	if(dwRet)
	{
		PostError("ETCreateDir",dwRet);
		goto END;
	}

	//ʹĬϿ֤̿ĬϿҪ滻ԼĿ
	dwRet = ETVerifyPin(&pContext[0],ET_DEFAULT_DEV_PIN,ET_DEV_PIN_LEN,ET_DEV_PIN);
	if(dwRet)
	{
		PostError("ETVerifyPin",dwRet);
		goto END;
	}

	//ATR
	dwRet = ETControl(&pContext[0],ET_SET_DEVICE_ATR,"ET199 VC TEST PROJECT           ",MAX_ATR_LEN,NULL,0,NULL);
	if(dwRet)
	{
		PostError("ETControl",dwRet);
		goto END;
	}

	//ȡATR
	dwRet = ETControl(&pContext[0],ET_GET_DEVICE_ATR,NULL,0,szAtr,MAX_ATR_LEN,NULL);
	if(dwRet)
	{
		PostError("ETControl",dwRet);
		goto END;
	}
	szAtr[MAX_ATR_LEN] = 0;

	printf("New Atr: %s\n",szAtr);
	
	//֤޸Ŀ̿
	dwRet = ETChangePin(&pContext[0],(BYTE*)"123456781234567812345678",24,(BYTE *)"876543218765432187654321",24,ET_DEV_PIN,0);
	if(dwRet)
	{
		PostError("ETChangePin",dwRet);
		goto END;
	}
	dwRet = ETChangePin(&pContext[0],(BYTE*)"876543218765432187654321",24,(BYTE *)"123456781234567812345678",24,ET_DEV_PIN,0);
	if(dwRet)
	{
		PostError("ETChangePin",dwRet);
		goto END;
	}
	
	//֤޸û
	dwRet = ETChangePin(&pContext[0],(BYTE*)"12345678",8,(BYTE *)"87654321",8,ET_USER_PIN,0);
	if(dwRet)
	{
		PostError("ETChangePin",dwRet);
		goto END;
	}
	dwRet = ETChangePin(&pContext[0],(BYTE*)"87654321",8,(BYTE *)"12345678",8,ET_USER_PIN,0);
	if(dwRet)
	{
		PostError("ETChangePin",dwRet);
		goto END;
	}

	//Ŀ¼Ҫ֤̿
	dwRet = ETVerifyPin(&pContext[0],(BYTE *)"123456781234567812345678",24,ET_DEV_PIN);
	if(dwRet)
	{
		PostError("ETVerifyPin",dwRet);
		goto END;
	}	

	//һĿ¼ΪһӦ
	dwRet = ETCreateDir(&pContext[0],"2000",60000,ET_CREATE_SUB_DIR);
	if(dwRet)
	{
		PostError("ETCreateDir",dwRet);
		goto END;
	}

	//ڴĿ¼ǰĿ¼ԶĿ¼Ҫ֤̿
	dwRet = ETVerifyPin(&pContext[0],(BYTE *)"123456781234567812345678",24,ET_DEV_PIN);
	if(dwRet)
	{
		PostError("ETVerifyPin",dwRet);
		goto END;
	}

	//5͵ļ
	dwRet = ETCreateFile(&pContext[0],"1001",1024,0);//ִļ
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		goto END;
	}
	printf("Create file 1001 \n");

	dwRet = ETCreateFile(&pContext[0],"1002",1024,1);//ļ
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		goto END;
	}
	printf("Create file 1002 \n");

	dwRet = ETCreateFile(&pContext[0],"1003",1024,2);//Կļ
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		goto END;
	}
	printf("Create file 1003 \n");

	dwRet = ETCreateFile(&pContext[0],"1004",1024,3);//˽Կļ
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		goto END;
	}
	printf("Create file 1004 \n");

	dwRet = ETCreateFile(&pContext[0],"1005",1024,4);//ڲִļ
	if(dwRet)
	{
		PostError("ETCreateFile",dwRet);
		goto END;
	}
	printf("Create file 1005 \n");

	dwRet = ETControl(&pContext[0],ET_GET_DF_AVAILABLE_SPACE,NULL,0,&DFSize,4,NULL);
	if(dwRet)
	{
		PostError("ETControl",dwRet);
		goto END;
	}
	printf("Current DF available size %d Bytes\n",DFSize);

	dwRet = ETGenRsaKey(&pContext[0],1024,65537,"1003","1004",&pubKeyData,&pubSize,&priKeyData,&priSize);
	if(dwRet)
	{
		PostError("ETGenRsaKey",dwRet);
		goto END;
	}

	hFile = CreateFile("hardware\\hardware.bin",GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		printf("open file hardware\\hardware.bin error %X\n",GetLastError());
		goto END;
	}
	
	FileSize = GetFileSize(hFile,NULL);
	if(FileSize >10240)
	{
		printf("File size too large!\n");
		goto END;
	}

	ReadFile(hFile,FileBuff,FileSize,&FileSize,NULL);

	dwRet = ETWriteFile(&pContext[0],"1001",0,FileBuff,FileSize);
	if(dwRet)
	{
		PostError("ETWriteFile",dwRet);
		goto END;
	}

	if(hFile != INVALID_HANDLE_VALUE)
		CloseHandle(hFile);

	dwRet = ETVerifyPin(&pContext[0],(BYTE *)"12345678",8,ET_USER_PIN);
	
	*((PWORD)InBuf) = 8;//8Ľ׳
	dwRet = ETExecute(&pContext[0],"1001",InBuf,2,OutBuf,128,NULL);
	if(dwRet)
	{
		PostError("ETExecute",dwRet);
		goto END;
	}
	printf("Execute result 8! = %d\n",*((PDWORD)OutBuf));


	//*******ʼ״̬***********/
		
	ETChangeDir(&pContext[0],"\\");
	//Ŀ¼Ҫ֤̿
	dwRet = ETVerifyPin(&pContext[0],(BYTE *)"123456781234567812345678",24,ET_DEV_PIN);
	if(dwRet)
	{
		PostError("ETVerifyPin",dwRet);
		goto END;
	}		

	//ɾĿ¼
	dwRet = ETEraseDir(&pContext[0],NULL);
	if(dwRet)
	{
		PostError("ETEraseDir",dwRet);
		goto END;
	}
	
	//Ŀ¼
	dwRet = ETCreateDir(&pContext[0],NULL,0,ET_CREATE_ROOT_DIR);
	if(dwRet)
	{
		PostError("ETCreateDir",dwRet);
		goto END;
	}

	//LEDƳ
	dwRet = ETControl(&pContext[0],ET_LED_UP,NULL,0,NULL,0,NULL);
	if(dwRet)
	{
		PostError("ETControl ET_LED_UP",dwRet);
		goto END;
	}

	ETClose(&pContext[0]);

END:
	
	delete [] pContext;

	return dwRet;
}
