#ifndef __SAMPLE_21_H__
#define __SAMPLE_21_H__

#define CMD_DES_ENC   0x01
#define CMD_DES_DEC   0x02
#define CMD_TDES_ENC  0x03
#define CMD_TDES_DEC  0x04


/**
 * By default, program compiled at PC has the address alignment issues which don't exist in C51 environment.
 * For convenience of data-handling,we use the compact-pack mode for storing the exchanging data-buffer 
 * used between PC and ET199 device.
 */
#ifdef _WIN32
#pragma pack(push, 1)
typedef double DOUBLE;
#endif

/**< file context */
typedef struct _CIPHER_CONTEXT
{
    BYTE bTag;
    BYTE bDataLen  ;            /*  data length */
    BYTE pbData[248] ;          /*  data */
}
CIPHER_CONTEXT;

#ifdef _WIN32
#pragma pack(pop)
#endif


#endif //__SAMPLE_21_H__