/**
 * Copyright (c) 2006-2012 ʯſƼ޹˾
 * All rights reserved.
 *
 * @brief 򿪵һӵļ豸ʾζ̲߳豸 .
 *
 * @version 2.0
 */

#include "stdafx.h"
#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <Windows.h>

#include "common.h"

HANDLE hMutex = NULL;
int EnterMutex( char * funName );
int LeaveMutex() ;

/**< ߳ */
unsigned long thread_func1();
unsigned long thread_func2();
unsigned long thread_func3();

/**< */
ET_CONTEXT pContextList[250] = {0} ;	//豸б

int main(int argc, char* argv[]) {


    DWORD dwThread_1_Id;
    DWORD dwThread_2_Id;
    DWORD dwThread_3_Id;
    HANDLE hThread1;
    HANDLE hThread2;
    HANDLE hThread3;

    ET_CONTEXT * pCtx = NULL;
    DWORD dwDeviceNumber = 0;					//ӵ豸
    DWORD dwResult  = 0;

    /**< ʼ豸б */
    dwDeviceNumber = 250 ;
    dwResult = ETEnum( pContextList , &dwDeviceNumber) ;
    if ( 0 != dwResult ) {
        printf("Enumerate device failed! <error code: 0x%08x>\n", dwResult);
         printf( "\nPress any key to continue...\n"  );
		while ( !kbhit( ) );
		return -1;
    }

    /**<  򿪵һ豸  */
    pCtx = pContextList +0 ;
    dwResult = ETOpen( pCtx );
    if (0 != dwResult) {
        printf("ETOpen for first device failed with error code:%d\n", dwResult);
        printf( "\nPress any key to continue...\n"  );
		while ( !kbhit( ) );
		return -1;
    }


    hThread1 = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)thread_func1, NULL, 0, &dwThread_1_Id);
    hThread2 = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)thread_func2, NULL, 0, &dwThread_2_Id);
    hThread3 = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)thread_func3, NULL, 0, &dwThread_3_Id);

    
    /* ȴ߳н*/
	WaitForSingleObject(hThread1, INFINITE);
	WaitForSingleObject(hThread2, INFINITE);
	WaitForSingleObject(hThread3 , INFINITE);
	
    /* ر߳ */
    if (hThread1 !=  NULL) {
        CloseHandle(hThread1);
    }

    if (hThread2 !=  NULL) {
        CloseHandle(hThread2);
    }

    ETClose( pCtx ) ;
	printf( "\nPress any key to continue...\n"  );
    while ( !kbhit( ) );
    return 0 ;
}

int EnterMutex( char * funName ) {
    hMutex = CreateMutex(
                 NULL,                  // no security descriptor
                 FALSE,                 // mutex not owned
                 "NameOfMutexObject");  // object name

    if (hMutex == NULL) {
        printf("Function '%s' createMutex error: %d\n", funName , GetLastError() );
        return 0 ;
    }

    WaitForSingleObject(hMutex, INFINITE);
    return 1 ;
}
int LeaveMutex() {
    if (! ReleaseMutex(hMutex)) {
        return 0;
    }
    return 1 ;
}

unsigned long thread_func1() {

    if ( ! EnterMutex("func1") ) return 0 ;

    if ( pContextList == NULL )	return -1 ;

    /**< get first device */
    ET_CONTEXT *pCtx = pContextList + 0 ;
    printf("\nfuncion 1 get first device and  deal with it ..... \n");
    /**< doing with the first device */

    for ( int i = 1 ;  i < 200000 ; i++) {
        if (i%1000 == 0) {
            printf("*");
            Sleep(10) ;
        }
        if ( i%60000 == 0 ) printf("\n");
    }
    printf("\n");

    /**< end doing */

    LeaveMutex();
    return 1;
}

unsigned long thread_func2() {
    if ( ! EnterMutex("func2") ) return 0 ;
    if ( pContextList == NULL )	return -1 ;

    /**< get first device */
    ET_CONTEXT *pCtx = pContextList + 0 ;
    printf("\nfuncion 2 get first device and  deal with it ..... \n");

    /**< doing with the first device */
    for ( int i = 1 ;  i < 200000 ; i++) {
        if (i%1000 == 0) {
            printf("#");
            Sleep(10) ;
        }
        if ( i%60000 == 0 ) printf("\n");
    }
    printf("\n");

    /**< end doing */
    LeaveMutex();
    return 1;
}

unsigned long thread_func3() {
    if ( ! EnterMutex("func3") ) return 0 ;
    if ( pContextList == NULL )	return -1 ;

    /**< get first device */
    ET_CONTEXT *pCtx = pContextList + 0 ;
    printf("\nfuncion 3 get first device and  deal with it ..... \n");
    /**< doing with the first device */

    for ( int i = 1 ;  i < 200000 ; i++) {
        if (i%1000 == 0) {
            printf("@");
            Sleep(10) ;
        }
        if ( i%60000 == 0 ) printf("\n");
    }
    printf("\n");

    /**< end doing */
    LeaveMutex();
    return 1;
}
