program delphiTest;

{$APPTYPE CONSOLE}
uses
  SysUtils,
  Math,
  Windows,
  helpET199 in 'helpET199.pas';

function  loadFileIntoDevice ( pCtx:PET_CONTEXT; lpDeviceFileID:PChar; dwDeviceFileType:Byte; lpszPCFilePath:string ): boolean;
var
dwResult :Longword;
File1: file;
pbBuffer: array[0..65535] of Byte;
dwFileSize : Longword ;
dwRead     : Integer ;
begin

 try

    AssignFile(file1, lpszPCFilePath );
    FileMode :=fmOpenRead; //Reset֮ǰFileModeΪֻģֻܴļ
    Reset(file1, 1);
    dwFileSize := FileSize(file1);

    if (dwFileSize = 0) then
    begin
      Result := False;
      exit;
    end;

    blockread(file1, pbbuffer, dwFileSize, dwRead );
    if (dwRead) <= 0 then
    begin
      Result := False;
      exit;
    end;


    dwResult := ETWriteFile( pCtx , lpDeviceFileID ,0 , @pbBuffer , dwFileSize);
    if ( dwResult  <> 0 ) then
    begin
      Result := False;
      exit;
    end;

    result := true ;
  finally
    closefile(file1);
  end;

end;



label FINAL_EXIT;
var
dwResult        :integer ;
dwContextNum    :Longword;
pContextList    :array[0..255] of ET_CONTEXT ;
pCtx            :PET_CONTEXT ;

Frq             :DWORD;
TokenSize       :DWORD;
DFSize          :DWORD;
pubKeyData      :array[0..500] of Char ;
priKeyData      :array[0..500] of Char ;
pubSize         :DWORD;
priSize         :DWORD ;

InBuf           :array[0..255] of Char  ;
OutBuf          :array[0..255] of Char  ;
szAtr           :array[0..MAX_ATR_LEN] of Char ;

K              :integer;
tempstr         :string ;
begin

  // о豸
 dwContextNum  := 254 ;
 dwResult := ETEnum(@pContextList , @dwContextNum ) ;

 //dwResult := 0 ;
 if dwResult <> 0 then begin
        WriteLn('Enumerate device failed with error code ' + IntToHex(dwResult,8) );
        exit;
  end;
  WriteLn('Find device : ' , dwContextNum ) ;

  //򿪵һ豸
  WriteLn('Open the first device ') ;
  pCtx  :=  @pContextList[0] ;
  dwResult := ETOpen( pCtx ) ;
  if dwResult <> 0  then begin
     WriteLn('Open the first device failed with error code ' + IntToHex(dwResult,8) );
     goto FINAL_EXIT;
  end;

  //豸Ϣ
  Write('COS Version: ',pCtx.dwVersion shr 8 and $ff, '.' ) ;
  tempstr := '00'+ inttostr(pCtx.dwVersion and  $ff) ;
  tempstr := Copy(tempstr,Length(tempstr)-2+1,2);
  WriteLn(tempstr) ;

  Write('HardSerial: ');
  for K := 0 to MAX_ID_LEN -1 do begin
        Write( IntToHex( pCtx.bID[ K ] , 2 ) );
  end;
  WriteLn('');

  WriteLn('ATR: ', StrPas(@pCtx.bAtr));
  WriteLn('Customer: ', IntToHex( pCtx.dwCustomer , 8 ));


  //ǷԼĿͻ , ԼļӦرȣ
  if PCtx.dwCustomer <> $34333231 then begin
     //goto FINAL_EXIT;
  end;

  //LED˸ ƵΪFrq
  ETControl( pCtx , ET_LED_WINK , @Frq , sizeof(Frq) , nil , 0 , nil );
  dwResult := ETControl(pCtx,ET_GET_DEVICE_USABLE_SPACE,nil,0,@TokenSize,4,nil);
  if dwResult <> 0 then begin
        WriteLn('Setup LED failed with error code ', IntToHex(dwResult,8));
        goto FINAL_EXIT;
  end;
  WriteLn('TokenSize: ', IntToStr(TokenSize) , ' BYTE');

  //лĿ¼
  WriteLn('Change to root dir(if exist)...');
  dwResult := ETChangeDir( pCtx , '\');
  if dwResult = 0  then begin
     //֤PIN , ʹĬϿ֤̿ĬϿҪ滻ԼĿ
     dwResult := ETVerifyPin(pCtx, PChar('123456781234567812345678'), 24, ET_DEV_PIN );
     if dwResult <> 0  then begin
        WriteLn('Verify the develop pin with root directory at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
      end;
     //ɾĿ¼
     dwResult := ETEraseDir( pCtx , nil );
     if dwResult <> 0 then begin
        WriteLn('Erase the root directory at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
     end;
   end;

   //Ŀ¼
   dwResult := ETCreateDir( pCtx , nil ,0 ,ET_CREATE_ROOT_DIR);
   if dwResult <> 0 then begin
     WriteLn('Create the root directory at the first device failed with error code ', IntToStr( dwResult));
     goto FINAL_EXIT;
   end;


   dwResult := ETVerifyPin(pCtx, PChar('123456781234567812345678'), 24, ET_DEV_PIN );
   if dwResult <> 0  then begin
        WriteLn('Verify the develop pin before setting DEVICE_ATR with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
   end;
   //ATR
   dwResult := ETControl( pCtx , ET_SET_DEVICE_ATR , 'ET199 VC TEST PROJECT           ',MAX_ATR_LEN , nil , 0 , nil );
   if dwResult <> 0 then begin
     WriteLn('Set the ATR at the first device failed with error code ', IntToHex(dwResult,8));
     goto FINAL_EXIT;
   end;

   //ȡATR
   dwResult := ETControl(pCtx,ET_GET_DEVICE_ATR,nil,0,szAtr,MAX_ATR_LEN,nil);
   if dwResult <> 0 then begin
     WriteLn('Get the ATR at the first device failed with error code ', IntToStr( dwResult));
     goto FINAL_EXIT;
   end;
   szAtr[MAX_ATR_LEN] := Char(0);
   WriteLn('The new Atr: ', szAtr );

    //֤޸Ŀ̿
    dwResult := ETChangePin( pCtx,PChar('123456781234567812345678'), 24 , PChar('876543218765432187654321') , 24 , ET_DEV_PIN , 0 );
    if dwResult <> 0 then begin
     WriteLn('Change the develop pin at the first device failed with error code ', IntToStr( dwResult));
     goto FINAL_EXIT;
    end;

    dwResult := ETChangePin( pCtx ,'876543218765432187654321',24,'123456781234567812345678',24,ET_DEV_PIN,0);
    if dwResult <> 0 then begin
     WriteLn('Restore the default develop pin at the first device failed with error code ', IntToStr( dwResult));
     goto FINAL_EXIT;
    end;

    //֤޸û
    dwResult := ETChangePin( pCtx , PChar('12345678'), 8 ,PChar('87654321') , 8 , ET_USER_PIN , 0 );
    if dwResult <> 0 then begin
     WriteLn('Change the user pin at the first device failed with error code ', IntToStr( dwResult));
     goto FINAL_EXIT;
    end;
    dwResult := ETChangePin(pCtx,PChar('87654321'),8,PChar('12345678'),8,ET_USER_PIN,0);
    if dwResult <> 0 then begin
     WriteLn('Restore the default user pin at the first device failed with error code ', IntToStr( dwResult));
     goto FINAL_EXIT;
    end;

   //Ŀ¼Ҫ֤̿
   dwResult := ETVerifyPin( pCtx , PChar('123456781234567812345678'), 24 , ET_DEV_PIN );
   if dwResult <> 0  then begin
        WriteLn('Verify the develop pin with root directory at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
   end;

   //һĿ¼ΪһӦ
   dwResult := ETCreateDir( pCtx , Pchar('2000') , 60000 , ET_CREATE_SUB_DIR );
   if dwResult <> 0 then begin
     WriteLn('Create the sub directory at the first device failed with error code ', IntToStr( dwResult));
     goto FINAL_EXIT;
   end;

   //ڴĿ¼ǰĿ¼ԶĿ¼Ҫ֤̿
   dwResult := ETVerifyPin( pCtx , PChar('123456781234567812345678'),24,ET_DEV_PIN);
   if dwResult <> 0  then begin
        WriteLn('Verify the develop pin with sub directory at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
   end;

  //5͵ļ
  WriteLn('Create file 1001 ......');
  dwResult := ETCreateFile( pCtx, PChar('1001'),1024,FILE_TYPE_EXE );//ִļ
  if dwResult <>0 then begin
        WriteLn('Create the exe file at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
  end;

  WriteLn('Create file 1002 ......');
  dwResult := ETCreateFile( pCtx, PChar('1002'),1024,FILE_TYPE_DATA );//ļ
  if dwResult <>0 then begin
        WriteLn('Create the data file at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
  end;

  WriteLn('Create file 1003 ......');
  dwResult := ETCreateFile( pCtx, PChar('1003'),1024,FILE_TYPE_RSA_PUBLIC );//Կļ
  if dwResult <>0 then begin
        WriteLn('Create the rsa public key file at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
  end;

  WriteLn('Create file 1004 ......');
  dwResult := ETCreateFile( pCtx, PChar('1004'),1024,FILE_TYPE_RSA_PRIVATE );//˽Կļ
  if dwResult <>0 then begin
        WriteLn('Create the rsa private key file at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
  end;

  WriteLn('Create file 1005 ......');
  dwResult := ETCreateFile( pCtx, PChar('1005'),1024,FILE_TYPE_INTERNAL_EXE );//ڲִļ
  if dwResult <>0 then begin
        WriteLn('Create the internal exe file at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
  end;


  dwResult := ETControl( pCtx , ET_GET_DF_AVAILABLE_SPACE , nil , 0 , @DFSize , 4 , nil);
  if dwResult <>0 then begin
        WriteLn('Get the current DF available size at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
  end;
  WriteLn('Current DF available size ', IntToStr(DFSize) , ' Bytes');


  //keyļ
  WriteLn('Gen rsa key file ......');
  pubSize := 500 ;
  priSize := 500 ;
  dwResult := ETGenRsaKey(pCtx,1024,65537,PChar('1003'),PChar('1004'),@pubKeyData,@pubSize,@priKeyData,@priSize);
  if dwResult <>0 then begin
        WriteLn('Gen rsa key at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
  end;

  //ؿִļ豸
  WriteLn('Download an exe file into device....... ') ;
  if( loadFileIntoDevice(pCtx , PChar('1001') , FILE_TYPE_EXE , 'hardware\hardware.bin' ) = false ) then
  begin
       WriteLn('Load the exe file  into the first device failed ! ' );
       goto FINAL_EXIT;
  end;

  //ִصļ
  WriteLn('Exec the file just download....... ') ;
  ETVerifyPin(pCtx,PChar('12345678') , 8 , ET_USER_PIN );
  (PWORD(@InBuf))^ := 8;//8Ľ׳
  dwResult := ETExecute( pCtx , PChar('1001') , @InBuf , 2 , @OutBuf , 128 , nil );
  if dwResult <>0 then begin
        WriteLn('Exec the file just download at the first device failed with error code ' + IntToHex(dwResult,8) );
        goto FINAL_EXIT;
  end;

  WriteLn('Execute result 8! = ', IntToStr( (PDWORD(@OutBuf))^)  );


FINAL_EXIT:
 //رմ򿪵豸
  dwResult := ETClose( pCtx ) ;
  if( dwResult<>0 ) then begin
     Write('Close the first device failed withe error code ' + IntToHex(dwResult,8) ) ;
  end ;


  Writeln;
  Writeln;
  Writeln('Hit <Enter> to exit!');
  Readln;

 end.
